import bpy, os, sys, configparser

# this is the pCars base folder where you have extracted all the bff files
# and also converted all the "*.bmt" files to "*.mtx" with "bmt2mtx.exe"
# use double backslashes \\ when using windows notation
mtx_base_dir = 'p:/Spiele/ProjectCARS/Pakfiles/TRACKS/Bannochbrae/'

# this is the folder with all extracted textures, preferably the folder where you build your ac track:
txt_base_dir = 'p:/acStuff/Bannochrea/Bannochbrae/texture'

def findInSubdirectory(filename, subdirectory=''):
    if subdirectory:
        path = subdirectory
    else:
        path = os.getcwd()
    for root, dirs, names in os.walk(path):
        if filename in names:
            return os.path.join(root, filename)
    return ''

i = 0
while i < len(bpy.data.materials):
    og_material = bpy.data.materials[i]
    skip = False
    bsdf = None
    if og_material.use_nodes:
        for n in og_material.node_tree.nodes:
            if n.type == 'TEX_IMAGE':
                if n.image and os.path.isfile(n.image.filepath):
                    skip = True

    if not skip:
        mtxfile = findInSubdirectory(og_material.name+'.mtx', mtx_base_dir)
        if mtxfile:
            firstDDS = ""
            lines = []

            with open(mtxfile) as f:
                lines = f.read().splitlines()
            last_1=""
            last_2=""
            for l in lines:
                if '.dds'in l.lower():
                    line = l.replace('<value v="', '').replace('" />','').split('\\')
                    if len(line)>0:
                        dds = line[len(line)-1]
                        if firstDDS == "":
                            firstDDS = txt_base_dir + '/' + dds
                        elif 'diffuseTexture' in last_2:
                            firstDDS = txt_base_dir + '/' + dds
                        # print(' - ' + dds)

                    # break
                last_2 = last_1
                last_1 = l

            if firstDDS != '' and os.path.isfile(firstDDS):
                print(og_material.name + '  ' + firstDDS)
                if not og_material.use_nodes:
                    og_material.use_nodes = True
                bsdf = og_material.node_tree.nodes["Principled BSDF"]
                texImage = og_material.node_tree.nodes.new('ShaderNodeTexImage')
                texImage.image = bpy.data.images.load(firstDDS)
                og_material.node_tree.links.new(bsdf.inputs['Base Color'], texImage.outputs['Color'])
    i += 1
