import bpy, os, sys, configparser

def findInSubdirectory(filename, subdirectory=''):
    if subdirectory:
        path = subdirectory
    else:
        path = os.getcwd()
    for root, dirs, names in os.walk(path):
        if filename in names:
            return os.path.join(root, filename)
    return ''

def setPersistenceValues(filename, valname, value):
    selected_obj = bpy.context.selected_objects.copy()
    if len(selected_obj) == 0:
        return {'CANCELLED'}

    fbxini = configparser.ConfigParser(inline_comment_prefixes=';')
    fbxini.optionxform=str # keep upper/lower case
    fbxini.read(filename)
    filen=os.path.basename(filename).replace('.ini', '')
    changed = 0

    for objs in selected_obj:
        sectname1 = 'model_FBX: ' + filen + '_' + objs.name
        sectname = 'model_FBX: ' + filen + '_' + objs.name + '_' + objs.name
        if fbxini.has_section(sectname) and fbxini.has_section(sectname1):
            if fbxini.has_option(sectname,valname):
                curr = fbxini.getfloat(sectname,valname)
                print('changed: ' + sectname + '  ' + valname + ' ' + str(curr) + ' -> ' + str(value))
                fbxini.set( sectname, valname, str(value) )
                changed += 1
        else:
            if not fbxini.has_section(sectname1):
                fbxini.add_section(sectname1)
                print('added: ' + sectname1)
                changed += 1
            if not fbxini.has_section(sectname):
                fbxini.add_section(sectname)
                print('added: ' + sectname)
                changed += 1
            fbxini.set(sectname1 , 'ACTIVE', str(1) )
            fbxini.set(sectname1 , 'PRIORITY', str(0) )
            fbxini.set(sectname  , 'ACTIVE', str(1) )
            fbxini.set(sectname  , 'PRIORITY', str(0) )
            fbxini.set(sectname  , 'VISIBLE', str(1) )
            fbxini.set(sectname  , 'TRANSPARENT', str(0) )
            fbxini.set(sectname  , 'CAST_SHADOWS', str(1) )
            fbxini.set(sectname  , 'LOD_IN', str(0) )
            fbxini.set(sectname  , 'LOD_OUT', str(1222) )
            fbxini.set(sectname  , 'RENDERABLE', str(1) )

            fbxini.set(sectname, valname, str(value) )

    if changed>0:
        with open(filename, 'w') as configfile:
            fbxini.write(configfile, space_around_delimiters=False)
        print('vals changed: ' + str(changed))
    else:
        print('noting changed')


### now a couple of example uses
### only for currently selected objects
### setPersistenceValues("persistence.fbx.ini", "valuename", value)

# bannochbrae_crowd.fbx.ini
setPersistenceValues("p:/acStuff/Bannochrea/Bannochbrae/rt_bannochbrae_crowd.fbx.ini", 'LOD_OUT', 366)


# rt_bannochbrae.fbx.ini
# setPersistenceValues("p:/acStuff/Bannochrea/Bannochbrae/rt_bannochbrae.fbx.ini", 'LOD_OUT', 700)
# setPersistenceValues("p:/acStuff/Bannochrea/Bannochbrae/rt_bannochbrae.fbx.ini", 'CAST_SHADOWS', 0)
# setPersistenceValues("p:/acStuff/Bannochrea/Bannochbrae/rt_bannochbrae.fbx.ini", 'TRANSPARENT', 1)


# rt_bannochbrae_veg.fbx.ini
# setPersistenceValues("p:/acStuff/Bannochrea/Bannochbrae/rt_bannochbrae_veg.fbx.ini", 'LOD_OUT', 700)
# setPersistenceValues("p:/acStuff/Bannochrea/Bannochbrae/rt_bannochbrae_veg.fbx.ini", 'TRANSPARENT', 0)

