import os, sys, configparser

fbxini = configparser.ConfigParser(inline_comment_prefixes=';')
fbxini.optionxform=str # keep upper/lower case

### use commandline arguments:
fbxini.read(   sys.argv[1]   )
mtx_base_dir = sys.argv[2]

### or comment out above two lines and put in stuff manually here:
### use double backslashes \\ when using windows notation
# fbxini.read(   'p:/acStuff/Bannochrea/Bannochbrae/rt_bannochbrae.fbx.ini' )
# mtx_base_dir = 'p:/Spiele/ProjectCARS/Pakfiles/TRACKS/Bannochbrae/'

def findInSubdirectory(filename, subdirectory=''):
    if subdirectory:
        path = subdirectory
    else:
        path = os.getcwd()
    for root, dirs, names in os.walk(path):
        if filename in names:
            return os.path.join(root, filename)
    return ''

for mats in fbxini.sections():
    if 'MATERIAL_' in mats:
        if fbxini.has_option(mats,'NAME') and fbxini.has_option(mats, 'RES_0_TEXTURE'):
            matname = fbxini.get(mats,'NAME')
            texname = fbxini.get(mats,'RES_0_TEXTURE')
            if texname == 'NULL':
                mtxfile = findInSubdirectory(matname+'.mtx', mtx_base_dir)
                if mtxfile:
                    print(mtxfile)
                    lines = []
                    with open(mtxfile) as f:
                        lines = f.read().splitlines()
                    for l in lines:
                        if '.dds'in l:
                            line = l.replace('<value v="', '').replace('" />','').split('\\')
                            if len(line)>0:
                                dds = line[len(line)-1]
                                fbxini.set(mats, 'RES_0_TEXTURE', dds)
                                print(mats + ' - ' + dds)
                            break

with open(sys.argv[1], 'w') as configfile:
    fbxini.write(configfile, space_around_delimiters=False) # dont use spaces around "="
