/*
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#include <string>
#include <sstream>
#include <stdio.h>
#include "EndSection.hh"
#include "sections.h"
#include "FileHandler.hh"

std::string EndSection::toXml()
{
    std::stringstream   theStream;
    std::string         theRval;
    
    theStream << "\t<END_SECTION />" << std::endl;
    
    theRval = theStream.str();
    return theRval;
}


void EndSection::toRaw(FileHandler* parFh)
{
    section_head theHead;
    theHead.name = parFh->swapBytes(SECTION_END);
    theHead.length = rawLength();
    theHead.blocks = 0;

    parFh->write(&theHead, sizeof(section_head), 1);
}

size_t EndSection::rawLength()
{
    return sizeof(section_head);
}
