/*
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef MATRICE__HH
#define MATRICE__HH

#include <stdio.h>
#include <string>

//Forward declarations
class FileHandler;
class XmlElement;

class Matrice
{
    private:
        float myOffsetX;
        float myOffsetY;
        float myOffsetZ;
        
        float myOrientationX;
        float myOrientationY;
        float myOrientationZ;
        float myOther1;
        float myOther2;
        int myId;
        int myParentId;
    public:
        Matrice(FILE* parFp, int parEndian, int parId = -1);
        Matrice(XmlElement* parXml);
        std::string toXml(int parLevel = 1);
        void toRaw(FileHandler* parFh);
};

#endif // MATRICE__HH
