/*
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef NODESECTION_HH
#define NODESECTION_HH

#include <stdio.h>
#include <string>
#include <sstream>
#include <iostream>
#include <vector>

#include "sections.h"

//Forward declarations
class ObjectId;
class FileHandler;
class XmlElement;


class NodeSection {
    private:
        std::string myTagName;
        SECTIONS myTag;
        std::vector<ObjectId*> myObjectIds;
    public:
        NodeSection(std::string parTagName = "SECTION_NODE", SECTIONS parTag = SECTION_NODE);
        ~NodeSection();
        void readSection(FILE* parFp, int endian, int num);
        void readSection(XmlElement* parXml);
        std::string toXml();
        size_t rawLength();
        void toRaw(FileHandler* parFh);
};

#endif

