/*
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef OBJECT__HH
#define OBJECT__HH

#include <stdint.h>
#include <stdio.h>
#include <string>
#include <vector>
//Forward declarations;
class Sphere;
class Matrice;
class FileHandler;
class XmlElement;

class Object {
    private:
        int                     myId;
        std::string*            myType;
        std::string*            myName;
        std::string*            myResource;
        std::vector<Object*>    myChildNodes;
        Sphere*                 mySphere;
        std::vector<Matrice*>   myMatrices;
        int                     myMatrixNumber;
        int                     myNumType;
        
        uint32_t                myUserFlags;    //For type OBJECT
        std::vector<float>      myLodDistances; //For type LOD
        
        int                     myLevel; //Just for indentation
        
        Object* followReference(FILE* parFp, size_t ref, int parEndian, int parLevel);
    public:
        Object(FILE* parFp, int parEndian, int parLevel = 1);
        Object(XmlElement* parXml, int parLevel = 1);
        ~Object();
        //void readBlock();
        std::string toXml();
        size_t rawLength();
        void toRaw(FileHandler* parFh);
};

#endif
