/*
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef OBJECTID__HH
#define OBJECTID__HH

#include <string>
#include <map>
#include <stdio.h>
#include "Object.hh"

class FileHandler;
class XmlElement;

class ObjectId {
    private:
        //length
        int             myNumber;
        int             myUnknown;
        int             myNumType;
        std::string*    myStr1;
        std::string*    myStr2;
        std::string*    myStr3;
        Object*         myObject;
        int hex2int(std::string parHex);
    public:
        ObjectId(FILE* parFp, int parEndian);
        ObjectId(XmlElement* parXml);
        ~ObjectId();
        std::string toXml();
        size_t  rawLength();
        void    toRaw(FileHandler* parFh);
};

#endif

