/*
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef PARTITION_HH
#define PARTITION_HH

#include <string>
#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include "AxisAlignedBoundingBox.hh"
#include "PartitionChild.hh"

//Forward declarations
class FileHandler;
class XmlElement;

class Partition
{
    private:
        AxisAlignedBoundingBox* myBox;
        int                     myFlag;
        int                     myId;
        std::vector<Partition*>         myChildPartitions;
        std::vector<PartitionChild*>    myObjects;
        int getMaxId();
        
    public:
        Partition(FileHandler* parFh, int parId=0);
        Partition(XmlElement* parXml);
        ~Partition();
        std::string toXml();
        int id();
        size_t rawLength();
        void toRaw(FileHandler* parFh);
};

#endif // PARTITION_HH
