/*
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#include <iostream>
#include <vector>
#include <string>
#include <sstream>

#include "SgbSection.hh"
#include "OcclSection.hh"
#include "NodeSection.hh"
#include "FlatSection.hh"
#include "EndSection.hh"

class SgbData
{
    private:
        SgbSection  mySgbSection;
        OcclSection myOcclSection;
        NodeSection myNodeSection;
        FlatSection myFlatSection;
        NodeSection mySummSection;
        EndSection  myEndSection;
        //--data
    public:
        SgbData();
        std::string toXml();
        int readSection(FILE* fp, int endian, block_t* theSection);
        void readRaw(std::string parFile);
        void saveRaw(std::string parFile, int parEndian);
        void readXml(std::string parFile);
        void saveXml(std::string parFile);
};
