/*
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#include <sstream>
#include "SgbSection.hh"
#include "sections.h"
#include "FileHandler.hh"
#include "XmlElement.hh"

void SgbSection::readSection(FILE* parFp, int endian, block_t* theSection)
{
    //myPartition = new Partition(parFp, endian, 0);
}


XmlElement* SgbSection::toXml()
{
    return new XmlElement("SGB_SECTION");
}

void SgbSection::toRaw(FileHandler* parFh)
{
    section_head theHead;
    theHead.name = parFh->swapBytes(SECTION_SGB);
    theHead.length = parFh->swapBytes(rawLength());
    theHead.blocks = 0x3; //?
    myUnknown = 0;

    parFh->write(&theHead, sizeof(section_head), 1);
    parFh->write(&myUnknown, sizeof(uint32_t), 1);
}

size_t SgbSection::rawLength()
{
    return sizeof(section_head)+sizeof(uint32_t);
}
