/*
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef SGBSECTION_HH
#define SGBSECTION_HH

#include <stdint.h>
#include <stdio.h>
#include <string>
#include <sstream>
#include "sections.h"

//Forward declarations
class FileHandler;
class XmlElement;

class SgbSection
{
    private:
        uint32_t myUnknown;
    public:
        void                readSection(FILE* parFp, int endian, block_t* theSection);
        XmlElement*         toXml();
        void                toRaw(FileHandler* parFh);
        size_t              rawLength();
};

#endif // SGBSECTION_HH
