/*
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef LIST__H
#define LIST__H
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>


enum SECTIONS {
    SECTION_SGB  = 0x20424753,
    SECTION_OCCL = 0x4C43434F,
    SECTION_NODE = 0x45444F4E,
    SECTION_FLAT = 0x54414C46,
    SECTION_SUMM = 0x4D4D5553,
    SECTION_END  = 0x20444E45,
    SECTION_DATA = 0x44415441 //My own addition
};



typedef struct {
    uint32_t name;
    uint32_t length;
    uint32_t blocks;
} section_head;


typedef struct block block_t;

struct block {
    uint32_t name;
    size_t start;
    size_t length;
    block_t* next;
};

void addSection(block_t** parBlocks, uint32_t parNname, size_t parStart, size_t parLength);
void freeSections(block_t** parBlocks);
block_t* findSections(FILE* fp, int endian);
block_t* findSection(block_t* parSections, uint32_t parName);
uint32_t referenceToSection(block_t* parSections, size_t offset);

#endif
